<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Insert title here</title>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>
<body>
<script type="text/javascript">
class User {
	constructor(name, age)
	{
		this.name = name;
		this.age = age;
	}
	
	showName() {
		console.log(this.name);
	}
}

const jung = new User("정해인", 25);
console.log(jung);
// prototype 속성에 showName이 들어감
console.log(jung.__proto__);

// 상속
class Student extends User {
	#school; // #을 앞에 붙이면 private로 설정된다.
	
	constructor(school) {
		super("홍길동", 30);
		this.#school = school;
	}
	
	study() {
		console.log(`${this.name}은 ${this.school}에서 공부합니다.`);
	}
	
	// 접근자 프로퍼티
	get school() {
		return this.#school;
	}
	
	set school(school) {
		this.#school = school;
	}
}

const hong = new Student("하버드");
hong.study();
console.log(hong);

console.log(hong.school);

console.log('#school' in hong); // false
console.log('school' in hong); // true
</script>
</body>
</html>